/** \file CahnHilliard_.h */

#ifndef CAHN_HILLIARD_H_
#define CAHN_HILLIARD_H_

#include "AMDiS.h"
#include "BaseProblem.h"
#include "ExtendedProblemStat.h"
#include "chns.h"

using namespace AMDiS;

class CahnHilliard_ : public BaseProblem<ProblemStat>
{
public: // definition of types

  typedef BaseProblem<ProblemStat> super;

public: // public methods

  CahnHilliard_(const std::string &name_, bool createProblem = true);
  ~CahnHilliard_();

  virtual void initData() {};
  virtual void solveInitialProblem(AdaptInfo *adaptInfo);

  double getEpsilon() { return eps; }
  int getDoubleWellType() { return doubleWell; }

protected: // protected methods

  virtual void fillOperators();
  virtual void fillBoundaryConditions() {}

protected: // protected variables

  bool useMobility;

  unsigned dim;

  int doubleWell;

  double gamma;
  double eps;
  double minusEps;
  double epsInv;
  double minusEpsInv;
  double epsSqr;
  double minusEpsSqr;
};

#endif // CAHN_HILLIARD_H_
